package com.cacheserverdeploy.deploy;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

import com.cacheserverdeploy.deploy.entity.ConsumVertex;
import com.cacheserverdeploy.deploy.entity.Edge;
import com.cacheserverdeploy.deploy.entity.IVertex;
import com.cacheserverdeploy.deploy.entity.Path;
import com.cacheserverdeploy.deploy.entity.Vertex;
import com.filetool.util.PermUtil;

public class Deploy
{
	//public static final int MAXVNUM = 1000;100000
	public static final int MAXNUM = 100000;
	private static Edge[][] graph;											// = new Path[MAXVNUM][MAXVNUM];
	
	public static Vertex[] vertexs;
	public static ConsumVertex[] comsumVertexs;
	
	private static int[][] comsumVertexsGraph;
	
	private static int numVertex;
	private static int numEdge;
	private static int numConsumVertex;
	
	
	private static int costVideoServer;
	
	private static List<Vertex> path = new ArrayList<>();
	private static List<int[]> uselessPrem = new ArrayList<>();
	private static TreeSet<Path> set = new TreeSet<>();
	
	
	public static void initGreedy() {
		Greedy.graph = getCopyArray(graph);
		Greedy.vertexs = vertexs;
		Greedy.comsumVertexs = comsumVertexs;
		
		Greedy.numConsumVertex = numConsumVertex;
		Greedy.numEdge = numEdge;
		Greedy.numVertex = numVertex;
		Greedy.costVideoServer = costVideoServer;
	}
	
	
	/**
     * todo
     * 
     * @param graphContent caseinfo
     * @return  caseouput info
     * @see [huawei]
     */
    public static String[] deployServer(String[] graphContent)
    {
    	
    	initGraph(graphContent);
    	initGreedy();
    	
    	
    	
    	
    	List<Integer> servers = Greedy.getServers();
    	List<Integer> leftServers = Greedy.getLeftServers();
    	System.out.println("leftServers:"+leftServers);
    	
    	System.out.println("最坏成本： " + numConsumVertex * costVideoServer);
    	
    	for (int i = 0; i < numConsumVertex; i++) {
    		int netVertex = comsumVertexs[i].getNetVertex();
    		
    		System.out.print(netVertex+", ");
		}
    	System.out.println();
    	
    	
    	
    	
    	Map<List<Integer>,Integer> tempPaths = null;
    //	int minCost = Integer.MAX_VALUE;
    	
    	
    	Map<List<Integer>,Integer> minPaths = new HashMap<>();
    	
    	
		int minCost = distributFlow(servers,graph,minPaths);//,vertexsCopy
		
		
		System.out.println("cost:"+minCost);

        List<Integer> minServers = new ArrayList<>();		
		 for (int i = 0; i < leftServers.size(); i++) {
			 servers.add(leftServers.get(i));
			 tempPaths = new HashMap<>();
			 clearFlow(graph);
			 int tempCost = distributFlow(servers,graph,tempPaths);
			 
			 if(tempCost < minCost) {
				 minPaths = new HashMap<>(tempPaths);
				 minCost = tempCost;
				 minServers = new ArrayList<>(servers);
			 }
		    	
		    	
		}
    	
    	
		 System.out.println("minCost:"+minCost);
    	 System.out.println("servers:" + minServers);
    	 
    	String[] relust = null; 
    	
    	
		if(minCost >= numConsumVertex * costVideoServer) {
			System.out.println("没有找到更优解");
    		relust = new String[numConsumVertex + 2];
    		relust[0] = numConsumVertex+"";
        	relust[1] = "\n";
        	
        	for (int i = 0; i < numConsumVertex; i++) {
        		relust[i + 2] = comsumVertexs[i].getNetVertex() + " " + comsumVertexs[i].getIndex() + " " + comsumVertexs[i].getBandwidth();
			}
        	
    		
    	} else {
    		relust = new String[minPaths.size() + 2];
        	
        	relust[0] = minPaths.size()+"";
        	relust[1] = "\n";
        	
        	
        	Iterator<List<Integer>> iterator = minPaths.keySet().iterator();
        	int i = 2;
        	while(iterator.hasNext()) {
        		StringBuilder sb = new StringBuilder();
        		List<Integer> key = iterator.next();
        		for (int j = 0; j < key.size(); j++) {
        			sb.append(key.get(j) + " ");
    			}
        		relust[i++] =  sb.toString() + "" +minPaths.get(key);
        		
        	}
        	
         	
        	
    	}
    	
    	
    	for (int i1 = 0; i1 < relust.length; i1++) {
			
    		System.out.println(relust[i1]);
		}
    	
    	

		
        return relust;
    }
	private static void clearFlow(Edge[][] graph) {
		
		for (int i = 0; i < graph.length; i++) {
			for (int j = 0; j < graph.length; j++) {
				if(graph[i][j]!=null) {
					graph[i][j].setLeftBandwidth(graph[i][j].getBandwidth());
				}
			}
		}
	}
    private static boolean isUselessPerm(int[] prem) {
		
    	for (int i = 0; i < uselessPrem.size(); i++) {
			
    		int[] js = uselessPrem.get(i);
    		
    		int m = 0;
    		int n = 0;
    		
    	
    		
    		while(n <= prem.length - 1 && m <= js.length - 1) {
    			if(js[m] == prem[n]) {
    				m ++;
    				n ++;
    			} else if(js[m] != prem[n]) {
    				m ++;
    			}
    			
    		}
    		if(m <= js.length  && n == prem.length ) {
    			return true;
    		}
    		
    		
    		
		}
    	
    	
    	
		return false;
	}

	public static  Edge[][] getCopyArray(Edge[][] a) {
    	Edge[][] b=new Edge[a.length][a.length];
    	/*for(int i=0;i<a.length;i++){
            b[i] = a[i].clone();
    	}*/
    	for (int i = 0; i < b.length; i++) {
			for (int j = 0; j < b.length; j++) {
				try {
					if( a[i][j] != null)
					b[i][j] = (Edge) a[i][j].clone();
					
					
					
				} catch (CloneNotSupportedException e) {
					
					e.printStackTrace();
				}
			}
		}
    	
    	
        return b;
    }
    
    public static int distributFlow(List<Integer> serverVertex,Edge[][] graph,Map<List<Integer>,Integer> paths) {
    	/*ArrayList<Integer> serverVertex = new ArrayList<>();
    	
    	for (int i = 0; i < serversArray.length; i++) {
    		serverVertex.add(serversArray[i]);
    		System.out.print(serversArray[i] + "  ");
		}
    	System.out.println();*/
    	
		//set startIndex
    	Vertex s = new Vertex();
		s.setIndex(numVertex);
		s.setVisited(false);
		//set startIndex net baseStation
		for (int j = 0; j < serverVertex.size(); j++) {
			int serverVertexIndex = serverVertex.get(j);
			Edge edge = new Edge(numVertex,serverVertexIndex,Integer.MAX_VALUE,0,Integer.MAX_VALUE);
			graph[numVertex][serverVertexIndex] = edge;
			s.addNextVertexs(vertexs[serverVertexIndex]);
		}
		vertexs[numVertex] = s;
		
		
		
		
		
    	
    
		Vertex t = new Vertex();
		t.setIndex(numVertex + 1);
		t.setVisited(false);
		for (int i = 0; i < numConsumVertex; i++) {
			vertexs[comsumVertexs[i].getNetVertex()].addNextVertexs(t);
		}
		vertexs[numVertex + 1] = t;
		//set endIndex
		for (int j = 0; j < numConsumVertex; j++) {
			int netVertexIndex = comsumVertexs[j].getNetVertex();
			Edge edge = new Edge(netVertexIndex,numVertex,comsumVertexs[j].getBandwidth(),0,comsumVertexs[j].getBandwidth());
			graph[netVertexIndex][t.getIndex()] = edge;
		}
		
		
		
		
		set.clear();
		path.clear();
		List<Integer> dijkstraRst = null;

		do {
			//System.out.println("111");
			dijkstraRst = dijkstra(graph,serverVertex);
			Collections.reverse(dijkstraRst);
			if(dijkstraRst.size() > 0) {
				int addFlow = addFlow(dijkstraRst, graph);
				List<Integer> path2 = getPath(dijkstraRst);
				paths.put(path2, addFlow);
				
			}
			
		} while (dijkstraRst.size() > 0);
		
		

		
		//System.out.println(getCost(graph,serversArray.length));
		return getCost(graph,serverVertex.size());
    }
    
    public static List<Integer> getPath(List<Integer> dijkstraRst) {
    	
    	
    	List<Integer> path = new ArrayList<>();
    	
    	/*if( dijkstraRst.size() == 3)
    		path.add(dijkstraRst.get(1));
    	else*/
	    	for (int i = 1; i < dijkstraRst.size() - 1; i++) {
				
	    		
	    		path.add(dijkstraRst.get(i));
			}
    	
    	Integer vertexIndex = dijkstraRst.get(dijkstraRst.size() - 2);
    	//System.out.println("vertexIndex:" +vertexIndex);
		path.add(getComsumVertexIndex(vertexIndex));
		return path;
    	
    }
    
    
	public static int getComsumVertexIndex(int vertexIndex) {
		
		for (int i = 0; i < comsumVertexs.length; i++) {
			if(vertexIndex == comsumVertexs[i].getNetVertex())
				return comsumVertexs[i].getIndex();
		}
		
		return -1;
		
	}
    public static List<int[]> getPerms(List<Integer> data,int sum) {
    	
    	
    	int[] a = new int[data.size()];
    	for (int i = 0; i < a.length; i++) {
			a[i] = data.get(i);					
		}
    	List<int[]> germs = null;
    	if(data.size() == sum) {
    		
    		germs = new ArrayList<>();
    		germs.add(a);
    		return germs;
    		
    		
	    }
    	
    	germs = PermUtil.combine(a, sum);
    	
    	
		return germs;
    	
    }
    
    
    
    public static List<Integer> deleteServer(Map<Integer,Integer> map) {
    	
    	List<Integer> deletVertex = new ArrayList<>();
    	Iterator<Integer> iterator2 = map.keySet().iterator();
    	while(iterator2.hasNext()) {
    		Integer key = iterator2.next();
    		if(map.get(key) < numConsumVertex * 2 - 2) {
    			deletVertex.add(key);
    			continue;
    		}
    		boolean isExist = isExsitInConsumVertexNet(key,map);
    		
    		if(!isExist && map.get(key) == numConsumVertex * 2 - 2) {
    			//System.out.println("shanchu"+key);
    			deletVertex.add(key);
    			List<Vertex> nextVertexs = vertexs[key].getNextVertexs();
    			for (int i = 0; i < nextVertexs.size(); i++) {
    				Vertex vertex = nextVertexs.get(i);
    				if(isExsitInConsumVertexNet(vertex.getIndex(),null)) {
    					//System.out.println("删除" + vertex.getIndex());
    					deletVertex.add(vertex.getIndex());
    				}
				}
    			
    			
		    }/**/
    		
    		if(isExist && (vertexs[key].getNextVertexs().size() <= 2)) {
    			//System.out.println("度为1  删除" + key);
    			deletVertex.add(key);
    		}/**/
    		
    		
    		
    		
    		
    	}
    	
    	for (int i = 0; i < deletVertex.size(); i++) {
    		map.remove(deletVertex.get(i));
		}
    	deletVertex.clear();
    	
    	
    	
    	Iterator<Integer> iterator = map.keySet().iterator();
    	List<Integer> keys = new ArrayList<>();
    	while(iterator.hasNext()) {
    		Integer key = iterator.next();
    		keys.add(key);
    	}
    	
    	deleteSmallNeib(map, keys, deletVertex);
    	
    	for (int i = 0; i < deletVertex.size(); i++) {
    		map.remove(deletVertex.get(i));
		}
    	
    	iterator = map.keySet().iterator();
    	List<Integer> servers = new ArrayList<>();
    	while(iterator.hasNext()) {
    		Integer key = iterator.next();
    		servers.add(key);
    	}
		return servers;
    	
    	
    }
    
    public static void deleteSmallNeib(Map<Integer,Integer> map,List<Integer> keys,List<Integer> deletVertex) {
    	//System.out.println(keys);
    	for (int i = 0; i < keys.size(); i++) {
    		
    		Integer value1 = map.get(keys.get(i));
    		
    		int n = 0;
    		int big = 0;
    		int small = 0;
			for (int j = 0; j < keys.size(); j++) {
				
				if(j == i) continue;
				
				Integer value2 = map.get(keys.get(j));
				
				
				
				if(graph[keys.get(i)][keys.get(j)] == null || deletVertex.contains(keys.get(j))) {
					
					continue;
				} 
		
				
				if(value1 > value2) {
					big ++;
				} else if(value1 < value2) {
					small ++;
				}
				
			}
			if(small >= 2 && big == 0) {
				deletVertex.add(keys.get(i));
				
				//System.out.println("deleteKey: " + keys.get(i) );
				
				//System.out.println(keys.get(i) +","+value1);
				keys.remove(keys.get(i));
				deleteSmallNeib(map, keys, deletVertex);
				break;
			}
			
			
		}
    	
    }
    
    
    public static boolean isExsitInConsumVertexNet(Integer key,Map<Integer,Integer> map) {
    	
    	for (int k = 0; k < numConsumVertex; k++) {
			if(key == comsumVertexs[k].getNetVertex()) {
				
				if(map != null) {
					Integer integer = map.get(key);
					int newValue = (int) (integer + comsumVertexs[k].getBandwidth() * 0.6);
					
					map.put(key, newValue);
				}
				
				
				
				return true;
				
			}
			
    	}
		return false;
    	
    }
    
    
    public static int getCost(Edge[][] graph,int serverCnt) {
    	
    	
    	int cost = 0;
    	
		for (int j = 0; j < numConsumVertex; j++) {
			int netVertexIndex = comsumVertexs[j].getNetVertex();
			//Edge edge = new Edge(netVertexIndex,numVertex,comsumVertexs[j].getBandwidth(),0,comsumVertexs[j].getBandwidth());
			if(graph[netVertexIndex][numVertex+1].getLeftBandwidth() != 0) return Integer.MAX_VALUE;
			//graph[netVertexIndex][numVertex] = edge;
		}
    	
    	
    	for (int i = 0; i < numVertex; i++) {
			for (int j = 0; j < numVertex; j++) {
				Edge edge = graph[i][j];
				if(edge != null) {
					int costBandWidth = edge.getBandwidth() - edge.getLeftBandwidth();
					cost = cost + costBandWidth*edge.getPrice();
				}
			}
		}
    	cost += costVideoServer*serverCnt;
		return cost;
    	
    }
    
    

    

    public static int addFlow(List<Integer> path,Edge[][] graph) {
    	
    	int minFlow = getMinFlow(path,graph);
    	//System.out.println("minFlow:" + minFlow);
    	addMinFlowToPath(path, minFlow,graph);
    	return minFlow;
    	
    }
    public static void addMinFlowToPath(List<Integer> listV,int flow,Edge[][] graph) {
    	if(flow == 0) return;
    	//List<Vertex> listV = path.getPath();
		for (int i = 0; i < listV.size() - 1; i++) {
			Edge edge = graph[listV.get(i)][listV.get(i + 1)];
			edge.setLeftBandwidth(edge.getLeftBandwidth() - flow);
			
			
		} 
		/*Edge edge = graph[listV.get(listV.size() - 2)][numVertex];
		edge.setLeftBandwidth(edge.getLeftBandwidth() - flow);*/
		
    }
 
    
    public static int getMinFlow(List<Integer> listV,Edge[][] graph) {
    	
    	//List<Vertex> listV = path.getPath();
    	int minFlow = Integer.MAX_VALUE;
    	int currentFlow = 0;
		for (int i = 0; i < listV.size() - 1; i++) {
			
			currentFlow = graph[listV.get(i)][listV.get(i + 1)].getLeftBandwidth();
			if(minFlow > currentFlow) {
				minFlow = currentFlow;
			} else if(minFlow == 0) {
				return 0;
			}
		}
		/*currentFlow = graph[listV.get(listV.size() - 2)][numVertex].getLeftBandwidth();
		if(minFlow > currentFlow) {
			minFlow = currentFlow;
		}   */
    	
		return minFlow;
    	
    }   
    
    public static void dfs(Vertex vertex,Edge[][] graph) {
		
    	if(vertex.isVisited()) return;
    	
    	
    	path.add(vertex);
    	vertex.setVisited(true);
    	if(vertex.getIndex() ==numVertex + 1) {
    		//System.out.println("1");
    		int weight = 0;
    		for (int i = 0; i < path.size() - 2; i++) {
    			
    			weight = weight + graph[path.get(i).getIndex()][path.get(i + 1).getIndex()].getPrice();
			}
    		
    		weight = weight + graph[path.get(path.size() - 2).getIndex()][numVertex].getPrice();
    		
    		Path pathPrice = new Path(new ArrayList<Vertex>(path), weight);
    		set.add(pathPrice);
    		
    		//pathWeight.put(new ArrayList<>(path), weight);
    		
    		//paths.add(new ArrayList<Vertex>(path));
    		path.remove(vertex);
    		vertex.setVisited(false);
    		return;
    	}
    	
    	for (int i = 0; i < vertex.getNextVertexs().size(); i++) {
			
    		dfs(vertex.getNextVertexs().get(i),graph);
    		
		}
    	
    	vertex.setVisited(false);
    	path.remove(vertex);
    
		
    	
    }
    
    
    public static void initGraph(String[] graphContent) {
    	
    	String[] numOfNet = graphContent[0].split(" ");
    	numVertex = Integer.valueOf(numOfNet[0]);
    	graph = new Edge[numVertex + 2][numVertex + 2];
    	
    	
    	vertexs = new Vertex[numVertex + 2]; //添加起点和终点
    	//vertexs.length;
    	numEdge = Integer.valueOf(numOfNet[1]);
    	numConsumVertex = Integer.valueOf(numOfNet[2]);
    	comsumVertexs = new ConsumVertex[numConsumVertex];
    	comsumVertexsGraph = new int[numConsumVertex][numConsumVertex];
    	
    	for (int i = 0; i < numConsumVertex; i++) {
			for (int j = 0; j < numConsumVertex; j++) {
				comsumVertexsGraph[i][j] = Integer.MAX_VALUE;
			}
		}
    	
    	
    	costVideoServer = Integer.valueOf(graphContent[2]);
    	
    	
    	for (int i = 4; i < graphContent.length; i++) {
			
    		String[] splitContent = graphContent[i].split(" ");
    		if(splitContent.length == 4) {
    			
    			
    			int v1 = Integer.valueOf(splitContent[0]);
    			int v2 = Integer.valueOf(splitContent[1]);
    			int bandwidth = Integer.valueOf(splitContent[2]);
    			int price = Integer.valueOf(splitContent[3]);
    			
    			
    			Edge edge1 = new Edge(v1,v2,bandwidth,price,bandwidth);
    			graph[v1][v2] = edge1;
    			
    			Edge edge2 = new Edge(v2,v1,bandwidth,price,bandwidth);
    			graph[v2][v1] = edge2;
    			if(vertexs[v1] == null) {
    				vertexs[v1] = new Vertex(false,v1);
    			} 
    			if(vertexs[v2] == null) {
    				vertexs[v2] = new Vertex(false,v2);
    			} 
    			vertexs[v1].addNextVertexs(vertexs[v2]);
    			vertexs[v2].addNextVertexs(vertexs[v1]);
    			
    		} else if(splitContent.length == 3) {
    			
    			int sonsumVertexId = Integer.valueOf(splitContent[0]);
    			int netVertexId = Integer.valueOf(splitContent[1]);
    			int bandwidth = Integer.valueOf(splitContent[2]);
    			if(comsumVertexs[sonsumVertexId] == null) {
    				comsumVertexs[sonsumVertexId] = new ConsumVertex(sonsumVertexId,bandwidth,netVertexId);
    			} 
    			
    		}
    		
		}
		//设置终点
		Vertex t = new Vertex();
		t.setIndex(numVertex + 1);
		t.setVisited(false);
		for (int i = 0; i < numConsumVertex; i++) {
			vertexs[comsumVertexs[i].getNetVertex()].addNextVertexs(t);
		}
		vertexs[numVertex + 1] = t;
		
		for (int j = 0; j < numConsumVertex; j++) {
			int netVertexIndex = comsumVertexs[j].getNetVertex();
			Edge edge = new Edge(netVertexIndex,numVertex+1,comsumVertexs[j].getBandwidth(),0,comsumVertexs[j].getBandwidth());
			graph[netVertexIndex][t.getIndex()] = edge;
		}

    	
    }
    
	public static List<Integer> dijkstra(Edge[][] graph, List<Integer> serverVertex)  {
		
		ArrayList<Vertex> vertexList = new ArrayList<>();
		
		int startIndex = numVertex;
		
		
		
		vertexList.add(vertexs[startIndex]);
		
		for (int i = 0; i < numVertex; i++) {
			vertexList.add(vertexs[i]);
		}
		vertexList.add(vertexs[numVertex + 1]);
		
		boolean[] hasVisited = new boolean[numVertex + 2];
		
		int[] prev = new int[numVertex + 2];
		
		int[] dist = new int[numVertex + 2];
		
		
		for (int i = 0; i < dist.length; i++) {
			
			if(graph[startIndex][vertexList.get(i).getIndex()] == null || graph[startIndex][vertexList.get(i).getIndex()].getLeftBandwidth() == 0) {
				
				dist[i] = MAXNUM;
				prev[i] = -1;
			} else {
				dist[i] = graph[startIndex][vertexList.get(i).getIndex()].getPrice();
				prev[i] = 0;
			}
			
		}

		hasVisited[0] = true;
		dist[0] = 0;
		for (int i = 1; i < dist.length; i++) {
			float minDist = MAXNUM;
			int u = 0;
			for (int j = 1; j < dist.length; j++) {
				if (!hasVisited[j] && dist[j] < minDist) {
					u = j;
					minDist = dist[j];
				}
			}
			
			if (u  == 0 || u== dist.length - 1)
				break;
			
			hasVisited[u] = true;
			for (int j = 1; j < dist.length; j++) {
				
				
				Edge edge = graph[vertexList.get(u).getIndex()][vertexList.get(j).getIndex()];
				if(edge != null && edge.getLeftBandwidth() != 0) {
					if (!hasVisited[j]) {
						if (dist[u] + edge.getPrice() < dist[j]) {
							dist[j] = dist[u] + edge.getPrice();
							prev[j] = u;
						}
					}
				}
				
				
			}
		}

		
		
		  
		
			
			
				
				
				int position = numVertex + 1;
				
				
				List<Integer> list = new ArrayList<>();
				list.add(vertexList.get(position).getIndex());
				while (position != 0) {
					
					position = prev[position];		
					if(position == -1 ) {
						list.clear();
						break;
					} else if(position == 0) {
						list.add(numVertex);
						break;
					} else
					list.add(vertexList.get(position).getIndex());
					
				}
				
				
			
			return list;
			
	
	}
	
	
	
	public static Map<Integer,List<Integer>> dijkstra(ConsumVertex startVertex)  {
		
		ArrayList<Vertex> vertexList = new ArrayList<>();
		
		
		 Map<Integer,List<Integer>> rstMap = new HashMap<>();
		int startIndex = vertexs[startVertex.getNetVertex()].getIndex();
		//rstMap.put(startVertex.getIndex(), 1);
		
		vertexList.add(vertexs[startIndex]);
		
		for (int i = 0; i < startIndex; i++) {
			vertexList.add(vertexs[i]);
		}
		
		for (int i = startIndex + 1; i < numVertex; i++) {
			 
			vertexList.add(vertexs[i]);
		}
		
		boolean[] hasVisited = new boolean[numVertex];
		
		int[] prev = new int[numVertex];
		
		float[] dist = new float[numVertex];
		
		
		for (int i = 0; i < dist.length; i++) {
			
			if(graph[startIndex][vertexList.get(i).getIndex()] == null) {
				dist[i] = MAXNUM;
				prev[i] = -1;
			} else {
				dist[i] = graph[startIndex][vertexList.get(i).getIndex()].getWeight();
				prev[i] = 0;
			}
			
		}

		hasVisited[0] = true;
		dist[0] = 0;
		for (int i = 1; i < dist.length; i++) {
			float minDist = MAXNUM;
			int u = 0;
			for (int j = 1; j < dist.length; j++) {
				if (!hasVisited[j] && dist[j] < minDist) {
					u = j;
					minDist = dist[j];
				}
			}
			
			if (u  == 0 )
				break;
			
			hasVisited[u] = true;
			for (int j = 1; j < dist.length; j++) {
				
				
				Edge edge = graph[vertexList.get(u).getIndex()][vertexList.get(j).getIndex()];
				if(edge != null) {
					if (!hasVisited[j]) {
						if (dist[u] + edge.getWeight() < dist[j]) {
							dist[j] = dist[u] + edge.getWeight();
							prev[j] = u;
						}
					}
				}
				
				
			}
		}

		
		
		  
		
			
			for (int j = 0; j < numConsumVertex; j++) {       
				
				int index = comsumVertexs[j].getNetVertex();
				int position;
				if(index == startIndex) {
					continue;
				} else if(index < startIndex) {
					position  = index + 1;
				} else {
					position  = index;
				}
				
				List<Integer> list = new ArrayList<>();
				list.add(vertexList.get(position).getIndex());
				while (position != 0) {
					
					position = prev[position];		
					if(position == -1 ) {
						break;
					} else if(position == 0) {
						list.add(startVertex.getNetVertex());
						break;
					} else
					list.add(vertexList.get(position).getIndex());
					
				}
				rstMap.put(comsumVertexs[j].getIndex(), list);
				
			}
			return rstMap;
			
			
	
	}
	
	
	
}
