package com.cacheserverdeploy.deploy;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import com.cacheserverdeploy.deploy.entity.ConsumVertex;
import com.cacheserverdeploy.deploy.entity.Edge;
import com.cacheserverdeploy.deploy.entity.Vertex;

public class Greedy {
	public static final int MAXNUM = 100000;
	public static Edge[][] graph;											// = new Path[MAXVNUM][MAXVNUM];
	
	public static Vertex[] vertexs;
	public static ConsumVertex[] comsumVertexs;
	
	public static int[][] comsumVertexsGraph;
	
	public static int numVertex;
	public static int numEdge;
	public static int numConsumVertex;
	
	public static int costVideoServer;
	
	private static List<Integer> servers = new ArrayList<>();
	
	
	private static List<Integer> satisfiedConsumVertex = new ArrayList<>();
	
	
	private static  float consumVRatio = 0.09f;
	
	
	private static  double priceRatio = 0.5;
	
	private static Map<Integer,Float> leftRst = new HashMap<>();
	
	public static int getLeftConsum() {
		
		
		for (int i = 0; i < comsumVertexs.length; i++) {
			
			if(!satisfiedConsumVertex.contains(comsumVertexs[i].getIndex())) {
				return comsumVertexs[i].getNetVertex();
			}
		}
		
		return Integer.MAX_VALUE;
		
	}
	
	
	
	public static List<Integer> getServers() {
		
			Map<List<Integer>,Integer> paths = new HashMap<>();
		
			
			while(satisfiedConsumVertex.size() <  numConsumVertex) {
				int server = getOneServer();
				
				System.out.println("server:" + server);
				servers.add(server);
				
				clearFlow(graph);
				
				distributFlow(servers, graph, paths);
				//System.out.println("-");
				//System.out.println(paths);
				
				//当前满足的所有消费节点
				List<Integer> satisfiedCons = getCurrentSatisfiedConsumVertexs();
				if(satisfiedCons == null) {
					System.out.println(servers + ",,,,");
					break;
				}
				System.out.println("satisfiedCons :"+ satisfiedCons);
				//从当前满足的消费节点中    删除一些点   剩余的点
				List<Integer> cons = getLeftConsumV(paths,satisfiedCons);
				System.out.println("cons"+ cons);
				addToSatisfiedConsumVertex(cons);
				System.out.println("final:" + satisfiedConsumVertex);
				
			}
				
			
			//自动调参  再来计算一次
			if(servers.size() >= numConsumVertex ) {
				System.out.println("自动调整参数");
				clearFlow(graph);
				//servers.clear();
				satisfiedConsumVertex.clear();
				
				consumVRatio = consumVRatio + 0.01f;
				System.out.println("consumVRatio:" +consumVRatio);
				if(consumVRatio > 0.2) return servers;
				
				
				servers = getServers();
			}
		
			
			//List<Integer> leftServers = getLeftServers();
			//System.out.println("leftServers:"+leftServers);
			System.out.println(servers + ",,,,");
		
			return servers;
		
		
	}
	
	
	
	
	
	public static List<Integer> getLeftServers() {
		
		int size = numConsumVertex - servers.size();
		
	//	System.out.println("servers:"+servers.size());
	//	System.out.println("numConsumVertex:"+numConsumVertex);
	//	System.out.println("left:"+size);
		List<Integer> leftServers = new ArrayList<>();
		
		List<Map.Entry<Integer, Float>> list = new ArrayList<>(leftRst.entrySet());
		
		Collections.sort(list, new Comparator<Map.Entry<Integer, Float>>() {

			@Override
			public int compare(Entry<Integer, Float> o1, Entry<Integer, Float> o2) {
				
				return -o1.getValue().compareTo(o2.getValue());
			}
		});
		
		System.out.println(list);
		int j = 0;
		for (int i = 0; i < list.size(); i++) {
			Integer key = list.get(i).getKey();
			//System.out.println("left:" + key);
			if(!servers.contains(key)) {
				leftServers.add(key);
				j ++;
				if(j == size || j == 10)
					break;
			}
			
			
		}
		
		
		return leftServers;
		
	}
	
	
	public static void addToSatisfiedConsumVertex(List<Integer> satisfiedCons) {
		
		for (int i = 0; i < satisfiedCons.size(); i++) {
			
			if(!satisfiedConsumVertex.contains(satisfiedCons.get(i))) {
				satisfiedConsumVertex.add(satisfiedCons.get(i));
			}
			
			
		}
		
	}
	
	
	private static List<Integer> getLeftConsumV(Map<List<Integer>, Integer> paths, List<Integer> satisfiedCons) {
		
		
		//Integer consumIndex:   Integer cost
		Map<Integer,Integer> costMap = new HashMap<>();
		
		
		Iterator<List<Integer>> iterator = paths.keySet().iterator();
		
		while(iterator.hasNext()) {
			
			List<Integer> key = iterator.next();
			Integer consumIndex = key.get(key.size() - 1);
			
			if(satisfiedCons.contains(consumIndex)) {
				//System.out.println("path:" + key);
				int pathPrice = getPathPrice(key);
				int cost = pathPrice * paths.get(key);
				
				if(costMap.containsKey(consumIndex)) {
					Integer value = costMap.get(consumIndex);
					value = value + cost;
					costMap.put(consumIndex, value);
				} else {
					costMap.put(consumIndex, cost);
				}
				
			}
			
		}
		
		
		List<Integer> returnSatisVertex = new ArrayList<>();
		
		Iterator<Integer> iterator2 = costMap.keySet().iterator();
		
		while(iterator2.hasNext()) {
			Integer key = iterator2.next();
			if(costMap.get(key) <= costVideoServer*priceRatio) {
				returnSatisVertex.add(key);
			}					
		}
		
		
		
		
		
		
		return returnSatisVertex;
	}
	
	
	
	public static int getPathPrice(List<Integer> path) {
		
		
		int cost = 0;
		for (int i = 0; i < path.size()-2; i++) {
			//System.out.println(path.get(i) + "," + path.get(i+1));
			cost = cost + graph[path.get(i)][path.get(i + 1)].getPrice();
				
		}
		
		return cost;
		
	}



	private static void clearFlow(Edge[][] graph) {
		
		for (int i = 0; i < graph.length; i++) {
			for (int j = 0; j < graph.length; j++) {
				if(graph[i][j]!=null) {
					graph[i][j].setLeftBandwidth(graph[i][j].getBandwidth());
				}
			}
		}
	}


	private static List<Integer> getCurrentSatisfiedConsumVertexs() {
		
		//if()
		int i= 0;
		List<Integer> fullConsumVertexs = new ArrayList<>();
		
		
		for (int j = 0; j < numConsumVertex; j++) {
			int netVertexIndex = comsumVertexs[j].getNetVertex();
			Edge edge = graph[netVertexIndex][numVertex + 1];
			
			if(edge.getLeftBandwidth() == 0) {
				i ++;
				if(!satisfiedConsumVertex.contains(comsumVertexs[j].getIndex()))
					fullConsumVertexs.add(comsumVertexs[j].getIndex());
			}
			
			
		}
		
		
		if(i == numConsumVertex) {
			System.out.println("满了");
			return null;
		}
		
		return fullConsumVertexs;
		
	}

	public static ConsumVertex isComsumVertex(int vertexIndex) {
		
		for (int i = 0; i < comsumVertexs.length; i++) {
			if(vertexIndex == comsumVertexs[i].getNetVertex())
				return comsumVertexs[i];
		}
		
		return null;
		
	}
	public static int getOneServer() {

		
    	Map<Integer,Float> map = new HashMap<>();
    	
    	for (int j = 0; j < numConsumVertex; j++) {
    		
    		
    		if(satisfiedConsumVertex.contains(comsumVertexs[j].getIndex())) {
    			continue;
    		}
    		
    		
    		Map<Integer, List<Integer>> rst = dijkstra(comsumVertexs[j]);
    		
    		
    		Set<Integer> keySet = rst.keySet();
    		   	
        	Iterator<Integer> iterator = keySet.iterator();
        	
        	while(iterator.hasNext()) {
        		
        		Integer key = iterator.next();
        		List<Integer> list = rst.get(key);
        		
        		for (int i = 0; i < list.size(); i++) {
        			
        			if(map.containsKey(list.get(i))) {
        				
        				
        				
        				Float d = map.get(list.get(i));
        				d = d  + 1;
        				map.put(list.get(i), d);
        				
        			} else {
        				map.put(list.get(i), 1.0f);
        			}
    			}
        	}
        
        	
        	Iterator<Integer> iterator2 = map.keySet().iterator();
        	float add = 0;
        	while(iterator2.hasNext()) {
        		Integer key = iterator2.next();
        		ConsumVertex comsumVertex = isComsumVertex(key);
    			if(comsumVertex != null) {
    				
    				add = (int) (comsumVertex.getBandwidth() * consumVRatio);  				
    				Float value = map.get(key);
    				map.put(key, value+add);
    			}
        		
    			
        		
        	}
        	
        	
        	
		}
    	
    	

    	System.out.println("qwewqewqewqe"+map);
    	leftRst = map;//保存一个指针
    	double maxValue = 0;
    	int maxKey = 0;
    	boolean isFind = false;
    	Iterator<Integer> iterator = map.keySet().iterator();
    	while(iterator.hasNext()) {
    		Integer key = iterator.next();
    		Float value = map.get(key);
    		if(maxValue < value && !servers.contains(key)) {
    			maxValue = value;
    			maxKey = key;
    			isFind = true;
    		}
    	}
    	
    	if(!isFind) return Integer.MAX_VALUE;
    	
		return maxKey;
	}
	
	
	public static Map<Integer,List<Integer>> dijkstra(ConsumVertex startVertex)  {
		
		ArrayList<Vertex> vertexList = new ArrayList<>();
		
		
		Map<Integer,List<Integer>> rstMap = new HashMap<>();
		int startIndex = vertexs[startVertex.getNetVertex()].getIndex();
		
		
		vertexList.add(vertexs[startIndex]);
		
		for (int i = 0; i < startIndex; i++) {
			vertexList.add(vertexs[i]);
		}
		
		for (int i = startIndex + 1; i < numVertex; i++) {
			 
			vertexList.add(vertexs[i]);
		}
		
		boolean[] hasVisited = new boolean[numVertex];
		
		int[] prev = new int[numVertex];
		
		float[] dist = new float[numVertex];
		
		
		for (int i = 0; i < dist.length; i++) {
			
			if(graph[startIndex][vertexList.get(i).getIndex()] == null) {
				dist[i] = MAXNUM;
				prev[i] = -1;
			} else {
				dist[i] = graph[startIndex][vertexList.get(i).getIndex()].getWeight();
				prev[i] = 0;
			}
			
		}

		hasVisited[0] = true;
		dist[0] = 0;
		for (int i = 1; i < dist.length; i++) {
			float minDist = MAXNUM;
			int u = 0;
			for (int j = 1; j < dist.length; j++) {
				if (!hasVisited[j] && dist[j] < minDist) {
					u = j;
					minDist = dist[j];
				}
			}
			
			if (u  == 0 )
				break;
			
			hasVisited[u] = true;
			for (int j = 1; j < dist.length; j++) {
				
				
				Edge edge = graph[vertexList.get(u).getIndex()][vertexList.get(j).getIndex()];
				if(edge != null) {
					if (!hasVisited[j] && edge.getLeftBandwidth() > 0) {
						if (dist[u] + edge.getWeight() < dist[j]) {
							dist[j] = dist[u] + edge.getWeight();
							prev[j] = u;
						}
					}
				}
				
				
			}
		}

		
		
		  
		
			
			for (int j = 0; j < numConsumVertex; j++) {  
				
	    		if(satisfiedConsumVertex.contains(comsumVertexs[j].getIndex())) {
	    			continue;
	    		}
	    		
				int index = comsumVertexs[j].getNetVertex();
				int position;
				if(index == startIndex) {
					continue;
				} else if(index < startIndex) {
					position  = index + 1;
				} else {
					position  = index;
				}
				
				List<Integer> list = new ArrayList<>();
				list.add(vertexList.get(position).getIndex());
				while (position != 0) {
					
					
					position = prev[position];		
					if(position == -1 ) {
						break;
					} else if(position == 0) {
						list.add(startVertex.getNetVertex());
						break;
					} else
					list.add(vertexList.get(position).getIndex());
					
				}
				rstMap.put(comsumVertexs[j].getIndex(), list);
				
			}
			return rstMap;
			
			
	
	}
	/**
	 * 分流
	 * @param serversArray
	 * @param graph
	 * @param paths
	 * @return
	 */
    public static void distributFlow(List<Integer> serverVertex,Edge[][] graph,Map<List<Integer>,Integer> paths) {
    	
    	Vertex s = new Vertex();
		s.setIndex(numVertex);
		s.setVisited(false);
		//复位图的起点边
		for (int i = 0; i < graph.length - 2; i++) {
			graph[numVertex][i] = null;
		}
		
		
		//set startIndex net baseStation
		for (int j = 0; j < serverVertex.size(); j++) {
			int serverVertexIndex = serverVertex.get(j);
			Edge edge = new Edge(numVertex,serverVertexIndex,Integer.MAX_VALUE,0,Integer.MAX_VALUE);
			//System.out.println("numVertex" + numVertex);
			//System.out.println("serverVertexIndex" + serverVertexIndex);
			graph[numVertex][serverVertexIndex] = edge;
			s.addNextVertexs(vertexs[serverVertexIndex]);
		}
		vertexs[numVertex] = s;
		
		
		
		
		
		List<Integer> dijkstraRst = null;

		do {
			
			dijkstraRst = dijkstra(graph);
			Collections.reverse(dijkstraRst);
			if(dijkstraRst.size() > 0) {
				int addFlow = addFlow(dijkstraRst, graph);
				List<Integer> path2 = getPath(dijkstraRst);
				paths.put(path2, addFlow);
			}
			
		} while (dijkstraRst.size() > 0);
		
		
		//return getCost(graph,serversArray.length);
    }
    public static List<Integer> getPath(List<Integer> dijkstraRst) {
    	
    	
    	List<Integer> path = new ArrayList<>();
    	
    	/*if( dijkstraRst.size() == 3)
    		path.add(dijkstraRst.get(1));
    	else*/
	    	for (int i = 1; i < dijkstraRst.size() - 1; i++) {
				
	    		
	    		path.add(dijkstraRst.get(i));
			}
    	
    	Integer vertexIndex = dijkstraRst.get(dijkstraRst.size() - 2);
    	//System.out.println("vertexIndex:" +vertexIndex);
		path.add(getComsumVertexIndex(vertexIndex));
		return path;
    	
    }
	public static int getComsumVertexIndex(int vertexIndex) {
		
		for (int i = 0; i < comsumVertexs.length; i++) {
			if(vertexIndex == comsumVertexs[i].getNetVertex())
				return comsumVertexs[i].getIndex();
		}
		
		return -1;
		
	}
	public static List<Integer> dijkstra(Edge[][] graph)  {
		
		ArrayList<Vertex> vertexList = new ArrayList<>();
		
		int startIndex = numVertex;
		
		
		
		vertexList.add(vertexs[startIndex]);
		
		for (int i = 0; i < numVertex; i++) {
			vertexList.add(vertexs[i]);
		}
		vertexList.add(vertexs[numVertex + 1]);
		
		boolean[] hasVisited = new boolean[numVertex + 2];
		
		int[] prev = new int[numVertex + 2];
		
		int[] dist = new int[numVertex + 2];
		
		
		for (int i = 0; i < dist.length; i++) {
			
			if(graph[startIndex][vertexList.get(i).getIndex()] == null || graph[startIndex][vertexList.get(i).getIndex()].getLeftBandwidth() == 0) {
				
				dist[i] = MAXNUM;
				prev[i] = -1;
			} else {
				dist[i] = graph[startIndex][vertexList.get(i).getIndex()].getPrice();
				prev[i] = 0;
			}
			
		}

		hasVisited[0] = true;
		dist[0] = 0;
		for (int i = 1; i < dist.length; i++) {
			float minDist = MAXNUM;
			int u = 0;
			for (int j = 1; j < dist.length; j++) {
				if (!hasVisited[j] && dist[j] < minDist) {
					u = j;
					minDist = dist[j];
				}
			}
			
			if (u  == 0 || u== dist.length - 1)
				break;
			
			hasVisited[u] = true;
			for (int j = 1; j < dist.length; j++) {
				
				
				Edge edge = graph[vertexList.get(u).getIndex()][vertexList.get(j).getIndex()];
				if(edge != null && edge.getLeftBandwidth() != 0) {
					if (!hasVisited[j]) {
						if (dist[u] + edge.getPrice() < dist[j]) {
							dist[j] = dist[u] + edge.getPrice();
							prev[j] = u;
						}
					}
				}
				
				
			}
		}

		
		
		  
		
			
			
				
				
				int position = numVertex + 1;
				
				
				List<Integer> list = new ArrayList<>();
				list.add(vertexList.get(position).getIndex());
				while (position != 0) {
					
					position = prev[position];		
					if(position == -1 ) {
						list.clear();
						break;
					} else if(position == 0) {
						list.add(numVertex);
						break;
					} else
					list.add(vertexList.get(position).getIndex());
					
				}
				
				
			
			return list;
			
	
	}
	

    public static int addFlow(List<Integer> path,Edge[][] graph) {
    	
    	int minFlow = getMinFlow(path,graph);
    	//System.out.println("minFlow:" + minFlow);
    	addMinFlowToPath(path, minFlow,graph);
    	return minFlow;
    	
    }
    public static void addMinFlowToPath(List<Integer> listV,int flow,Edge[][] graph) {
    	if(flow == 0) return;
    	//List<Vertex> listV = path.getPath();
		for (int i = 0; i < listV.size() - 1; i++) {
			Edge edge = graph[listV.get(i)][listV.get(i + 1)];
			edge.setLeftBandwidth(edge.getLeftBandwidth() - flow);
			
			
		} 
		
    }
 
    
    public static int getMinFlow(List<Integer> listV,Edge[][] graph) {
    	
    	//List<Vertex> listV = path.getPath();
    	int minFlow = Integer.MAX_VALUE;
    	int currentFlow = 0;
		for (int i = 0; i < listV.size() - 1; i++) {
			
			currentFlow = graph[listV.get(i)][listV.get(i + 1)].getLeftBandwidth();
			if(minFlow > currentFlow) {
				minFlow = currentFlow;
			} else if(minFlow == 0) {
				return 0;
			}
		}
    	
		return minFlow;
    	
    }   
    
}
