package com.cacheserverdeploy.deploy;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.cacheserverdeploy.deploy.entity.ConsumVertex;
import com.cacheserverdeploy.deploy.entity.Edge;
import com.cacheserverdeploy.deploy.entity.Vertex;

public class GreedyConsum {
	public static final int MAXNUM = 100000;
	public static Edge[][] graph;											// = new Path[MAXVNUM][MAXVNUM];
	
	public static Vertex[] vertexs;
	public static ConsumVertex[] comsumVertexs;
	
	public static int[][] comsumVertexsGraph;
	
	public static int numVertex;
	public static int numEdge;
	public static int numConsumVertex;
	
	public static int costVideoServer;
	
	private static List<Integer> servers = new ArrayList<>();
	
	
	private static List<Integer> satisfiedConsumVertex = new ArrayList<>();
	
	public static int getLeftConsum() {
		
		
		for (int i = 0; i < comsumVertexs.length; i++) {
			
			if(!satisfiedConsumVertex.contains(comsumVertexs[i].getIndex())) {
				return comsumVertexs[i].getNetVertex();
			}
		}
		
		return Integer.MAX_VALUE;
		
	}
	
	public static int getMaxFlowConsumVertex() {
		
		
		
		int max = 0;
		int index = 0;
		for (int j = 0; j < numConsumVertex; j++) {
		    		
		    		
    		if(satisfiedConsumVertex.contains(comsumVertexs[j].getIndex())) {
    			continue;
    		}
    		if(max < comsumVertexs[j].getBandwidth()) {
    			max =  comsumVertexs[j].getBandwidth();
    			index =  comsumVertexs[j].getIndex();
    		}
    		
    		
    		
		}
		
		satisfiedConsumVertex.add(index);
		return index;
		
	}
	
	
	public static List<Integer> getServers() {
		
		
		int maxFlowConsumVertex = getMaxFlowConsumVertex();
		servers.add(maxFlowConsumVertex);
		
		distributFlow(servers, graph);
		
		
		
		
		
		
		
		
		
		
		
		
		/*while(satisfiedConsumVertex.size() < numConsumVertex) {
			int server = getOneServer();
			if(server == Integer.MAX_VALUE) {
				server = getLeftConsum();
				System.out.println(server + "--------------");
				servers.add(server);
				break;
			} 
			
			servers.add(server);
			
			clearFlow(graph);
			
			distributFlow(servers, graph);
			
			
			
			getsatisfiedConsumVertexs();
			
			System.out.println(server + ",,,,");
			System.out.println("satisfiedConsumVertex"+satisfiedConsumVertex);
		}*/
		
		
		
		
		
		return servers;
		
	}
	
	
	private static void clearFlow(Edge[][] graph) {
		
		for (int i = 0; i < graph.length; i++) {
			for (int j = 0; j < graph.length; j++) {
				if(graph[i][j]!=null) {
					graph[i][j].setLeftBandwidth(graph[i][j].getBandwidth());
				}
			}
		}
	}


	private static void getsatisfiedConsumVertexs() {
		for (int j = 0; j < numConsumVertex; j++) {
			int netVertexIndex = comsumVertexs[j].getNetVertex();
			Edge edge = graph[netVertexIndex][numVertex + 1];
			
			if(edge.getLeftBandwidth() == 0) {
				
				
				if(!satisfiedConsumVertex.contains(comsumVertexs[j].getIndex()))
				satisfiedConsumVertex.add(comsumVertexs[j].getIndex());
			}
			
			
		}
		
	}

	public static ConsumVertex isComsumVertex(int vertexIndex) {
		
		for (int i = 0; i < comsumVertexs.length; i++) {
			if(vertexIndex == comsumVertexs[i].getNetVertex())
				return comsumVertexs[i];
		}
		
		return null;
		
	}
	public static int getOneServer() {

		
    	Map<Integer,Integer> map = new HashMap<>();
    	
    	for (int j = 0; j < numConsumVertex; j++) {
    		
    		
    		if(satisfiedConsumVertex.contains(comsumVertexs[j].getIndex())) {
    			continue;
    		}
    		
    		
    		Map<Integer, List<Integer>> rst = dijkstra(comsumVertexs[j]);
    		
    	//	System.out.println("dijstra,," + j +"--"+ rst);
    		Set<Integer> keySet = rst.keySet();
    		   	
        	Iterator<Integer> iterator = keySet.iterator();
        	
        	while(iterator.hasNext()) {
        		
        		Integer key = iterator.next();
        		List<Integer> list = rst.get(key);
        		
        		for (int i = 0; i < list.size(); i++) {
        			
        			if(map.containsKey(list.get(i))) {
        				
        				
        				
        				Integer integer = map.get(list.get(i));
        				integer ++;
        				map.put(list.get(i), integer);
        				
        			} else {
        				map.put(list.get(i), 1);
        			}
    			}
        	}
        
        	
        	Iterator<Integer> iterator2 = map.keySet().iterator();
        	int add = 0;
        	while(iterator2.hasNext()) {
        		Integer key = iterator2.next();
        		ConsumVertex comsumVertex = isComsumVertex(key);
    			if(comsumVertex != null) {
    				add = (int) (comsumVertex.getBandwidth() * 0.05);
    				
    				
    				Integer value = map.get(key);
    				map.put(key, value+add);
    			}
        		
    			
        		
        	}
        	
        	
        	
		}
    	
    	

    	System.out.println("qwewqewqewqe"+map);
    	
    	int maxValue = 0;
    	int maxKey = 0;
    	boolean isFind = false;
    	Iterator<Integer> iterator = map.keySet().iterator();
    	while(iterator.hasNext()) {
    		Integer key = iterator.next();
    		Integer value = map.get(key);
    		if(maxValue < value && !servers.contains(key)) {
    			maxValue = value;
    			maxKey = key;
    			isFind = true;
    		}
    	}
    	
    	if(!isFind) return Integer.MAX_VALUE;
    	
		return maxKey;
	}
	
	
	public static Map<Integer,List<Integer>> dijkstra(ConsumVertex startVertex)  {
		
		ArrayList<Vertex> vertexList = new ArrayList<>();
		
		
		Map<Integer,List<Integer>> rstMap = new HashMap<>();
		int startIndex = vertexs[startVertex.getNetVertex()].getIndex();
		
		
		vertexList.add(vertexs[startIndex]);
		
		for (int i = 0; i < startIndex; i++) {
			vertexList.add(vertexs[i]);
		}
		
		for (int i = startIndex + 1; i < numVertex; i++) {
			 
			vertexList.add(vertexs[i]);
		}
		
		boolean[] hasVisited = new boolean[numVertex];
		
		int[] prev = new int[numVertex];
		
		float[] dist = new float[numVertex];
		
		
		for (int i = 0; i < dist.length; i++) {
			
			if(graph[startIndex][vertexList.get(i).getIndex()] == null) {
				dist[i] = MAXNUM;
				prev[i] = -1;
			} else {
				dist[i] = graph[startIndex][vertexList.get(i).getIndex()].getWeight();
				prev[i] = 0;
			}
			
		}

		hasVisited[0] = true;
		dist[0] = 0;
		for (int i = 1; i < dist.length; i++) {
			float minDist = MAXNUM;
			int u = 0;
			for (int j = 1; j < dist.length; j++) {
				if (!hasVisited[j] && dist[j] < minDist) {
					u = j;
					minDist = dist[j];
				}
			}
			
			if (u  == 0 )
				break;
			
			hasVisited[u] = true;
			for (int j = 1; j < dist.length; j++) {
				
				
				Edge edge = graph[vertexList.get(u).getIndex()][vertexList.get(j).getIndex()];
				if(edge != null) {
					if (!hasVisited[j] && edge.getLeftBandwidth() > 0) {
						if (dist[u] + edge.getWeight() < dist[j]) {
							dist[j] = dist[u] + edge.getWeight();
							prev[j] = u;
						}
					}
				}
				
				
			}
		}

		
		
		  
		
			
			for (int j = 0; j < numConsumVertex; j++) {  
				
	    		if(satisfiedConsumVertex.contains(comsumVertexs[j].getIndex())) {
	    			continue;
	    		}
	    		
				int index = comsumVertexs[j].getNetVertex();
				int position;
				if(index == startIndex) {
					continue;
				} else if(index < startIndex) {
					position  = index + 1;
				} else {
					position  = index;
				}
				
				List<Integer> list = new ArrayList<>();
				list.add(vertexList.get(position).getIndex());
				while (position != 0) {
					
					
					position = prev[position];		
					if(position == -1 ) {
						break;
					} else if(position == 0) {
						list.add(startVertex.getNetVertex());
						break;
					} else
					list.add(vertexList.get(position).getIndex());
					
				}
				rstMap.put(comsumVertexs[j].getIndex(), list);
				
			}
			return rstMap;
			
			
	
	}
	/**
	 * 分流
	 * @param serversArray
	 * @param graph
	 * @param paths
	 * @return
	 */
    public static void distributFlow(List<Integer> serverVertex,Edge[][] graph) {
    	
    	Vertex s = new Vertex();
		s.setIndex(numVertex);
		s.setVisited(false);
		//复位图的起点边
		for (int i = 0; i < graph.length - 2; i++) {
			graph[numVertex][i] = null;
		}
		
		
		//set startIndex net baseStation
		for (int j = 0; j < serverVertex.size(); j++) {
			int serverVertexIndex = serverVertex.get(j);
			Edge edge = new Edge(numVertex,serverVertexIndex,Integer.MAX_VALUE,0,Integer.MAX_VALUE);
			//System.out.println("numVertex" + numVertex);
			//System.out.println("serverVertexIndex" + serverVertexIndex);
			graph[numVertex][serverVertexIndex] = edge;
			s.addNextVertexs(vertexs[serverVertexIndex]);
		}
		vertexs[numVertex] = s;
		
		
		
		
		
		List<Integer> dijkstraRst = null;

		do {
			
			dijkstraRst = dijkstra(graph);
			Collections.reverse(dijkstraRst);
			if(dijkstraRst.size() > 0) {
				int addFlow = addFlow(dijkstraRst, graph);
			}
			
		} while (dijkstraRst.size() > 0);
		
		
		//return getCost(graph,serversArray.length);
    }
    
	public static List<Integer> dijkstra(Edge[][] graph)  {
		
		ArrayList<Vertex> vertexList = new ArrayList<>();
		
		int startIndex = numVertex;
		
		
		
		vertexList.add(vertexs[startIndex]);
		
		for (int i = 0; i < numVertex; i++) {
			vertexList.add(vertexs[i]);
		}
		vertexList.add(vertexs[numVertex + 1]);
		
		boolean[] hasVisited = new boolean[numVertex + 2];
		
		int[] prev = new int[numVertex + 2];
		
		int[] dist = new int[numVertex + 2];
		
		
		for (int i = 0; i < dist.length; i++) {
			
			if(graph[startIndex][vertexList.get(i).getIndex()] == null || graph[startIndex][vertexList.get(i).getIndex()].getLeftBandwidth() == 0) {
				
				dist[i] = MAXNUM;
				prev[i] = -1;
			} else {
				dist[i] = graph[startIndex][vertexList.get(i).getIndex()].getPrice();
				prev[i] = 0;
			}
			
		}

		hasVisited[0] = true;
		dist[0] = 0;
		for (int i = 1; i < dist.length; i++) {
			float minDist = MAXNUM;
			int u = 0;
			for (int j = 1; j < dist.length; j++) {
				if (!hasVisited[j] && dist[j] < minDist) {
					u = j;
					minDist = dist[j];
				}
			}
			
			if (u  == 0 || u== dist.length - 1)
				break;
			
			hasVisited[u] = true;
			for (int j = 1; j < dist.length; j++) {
				
				
				Edge edge = graph[vertexList.get(u).getIndex()][vertexList.get(j).getIndex()];
				if(edge != null && edge.getLeftBandwidth() != 0) {
					if (!hasVisited[j]) {
						if (dist[u] + edge.getPrice() < dist[j]) {
							dist[j] = dist[u] + edge.getPrice();
							prev[j] = u;
						}
					}
				}
				
				
			}
		}

		
		
		  
		
			
			
				
				
				int position = numVertex + 1;
				
				
				List<Integer> list = new ArrayList<>();
				list.add(vertexList.get(position).getIndex());
				while (position != 0) {
					
					position = prev[position];		
					if(position == -1 ) {
						list.clear();
						break;
					} else if(position == 0) {
						list.add(numVertex);
						break;
					} else
					list.add(vertexList.get(position).getIndex());
					
				}
				
				
			
			return list;
			
	
	}
	

    public static int addFlow(List<Integer> path,Edge[][] graph) {
    	
    	int minFlow = getMinFlow(path,graph);
    	//System.out.println("minFlow:" + minFlow);
    	addMinFlowToPath(path, minFlow,graph);
    	return minFlow;
    	
    }
    public static void addMinFlowToPath(List<Integer> listV,int flow,Edge[][] graph) {
    	if(flow == 0) return;
    	//List<Vertex> listV = path.getPath();
		for (int i = 0; i < listV.size() - 1; i++) {
			Edge edge = graph[listV.get(i)][listV.get(i + 1)];
			edge.setLeftBandwidth(edge.getLeftBandwidth() - flow);
			
			
		} 
		
    }
 
    
    public static int getMinFlow(List<Integer> listV,Edge[][] graph) {
    	
    	//List<Vertex> listV = path.getPath();
    	int minFlow = Integer.MAX_VALUE;
    	int currentFlow = 0;
		for (int i = 0; i < listV.size() - 1; i++) {
			
			currentFlow = graph[listV.get(i)][listV.get(i + 1)].getLeftBandwidth();
			if(minFlow > currentFlow) {
				minFlow = currentFlow;
			} else if(minFlow == 0) {
				return 0;
			}
		}
    	
		return minFlow;
    	
    }   
    
}
