package com.cacheserverdeploy.deploy;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.cacheserverdeploy.deploy.entity.ConsumVertex;
import com.cacheserverdeploy.deploy.entity.Edge;
import com.cacheserverdeploy.deploy.entity.IVertex;
import com.cacheserverdeploy.deploy.entity.Vertex;

public class OutPut {
	
	private static List<IVertex> path = new ArrayList<>();
	private static Map<List<IVertex>,Integer> paths = new HashMap<>();
	//private static ConsumVertex[] comsumVertexs;
	
	public static Edge[][] graph;
	
	
	public static Map<List<IVertex>,Integer> getPaths(Edge[][] graph,int[] servers) {
		
		OutPut.graph = graph;
		
		for (int i = 0; i < servers.length; i++) {
			path.clear();
			System.out.println(servers[i]);
			dfs(Deploy.vertexs[servers[i]]);
			
		}
		
		
		
		return paths;
		
	}
	
	
	public static void dfs(Vertex vertex) {
		
		if(vertex.isVisited()) return;
		
		
		
		
		path.add(vertex);
    	vertex.setVisited(true);
    	ConsumVertex comsumVertex = isComsumVertex(vertex);
		if(comsumVertex != null) {
			
    		int flow = addFlow(path, graph);
    		path.add(comsumVertex);
    		System.out.println(path + "," + flow);
    		
    		
    		
    		paths.put(new ArrayList<IVertex>(path),flow);
    		
    		path.remove(comsumVertex);
    		path.remove(vertex);
    		vertex.setVisited(false);
    		
    		return;
    	}
    	for (int i = 0; i < vertex.getNextVertexs().size(); i++) {
    		Vertex nextV = vertex.getNextVertexs().get(i);
    		if(isEdgeCanGo(graph[vertex.getIndex()][nextV.getIndex()])) 
    			dfs(vertex.getNextVertexs().get(i));
    		
		}
    	
    	vertex.setVisited(false);
    	path.remove(vertex);
    	
		
		
	}
	public static boolean isEdgeCanGo(Edge edge) {
		
		if(edge != null && edge.getLeftBandwidth() < edge.getBandwidth()) {
			return true;
		}
		
		return false;
		
	}
	
	
	public static ConsumVertex isComsumVertex(Vertex vertex) {
		
		for (int i = 0; i < Deploy.comsumVertexs.length; i++) {
			if(vertex.getIndex() == Deploy.comsumVertexs[i].getNetVertex())
				return Deploy.comsumVertexs[i];
		}
		
		return null;
		
	}
	
    public static int addFlow(List<IVertex> path,Edge[][] graph) {
    	
    	int minFlow = getMinFlow(path,graph);
    	addMinFlowToPath(path, minFlow,graph);
    	return minFlow;
    	
    }
    public static void addMinFlowToPath(List<IVertex> listV,int flow,Edge[][] graph) {
    	if(flow == 0) return;
		for (int i = 0; i < listV.size() - 1; i++) {
			Edge edge = graph[listV.get(i).getIndex()][listV.get(i + 1).getIndex()];
			edge.setLeftBandwidth(edge.getLeftBandwidth() + flow);
			
			
		} 
		
    }
 
    
    public static int getMinFlow(List<IVertex> listV,Edge[][] graph) {
    	
    	
    	int minFlow = Integer.MAX_VALUE;
    	int currentUseFlow = 0;
    	
    	if(listV.size() == 1) {
    		
    		Edge edge = graph[listV.get(0).getIndex()][graph.length - 1];
    		
    		return (edge.getBandwidth() - edge.getLeftBandwidth());
    	}
    	
    	
		for (int i = 0; i < listV.size() - 1; i++) {
			
			Edge edge = graph[listV.get(i).getIndex()][listV.get(i + 1).getIndex()];
			
			currentUseFlow = (edge.getBandwidth() - edge.getLeftBandwidth());
			if(minFlow > currentUseFlow) {
				minFlow = currentUseFlow;
			} else if(minFlow == 0) {
				return 0;
			}
		}
    	
		return minFlow;
    	
    }   
  
	
}
